namespace SVN_NET
{
	using System;
	using Microsoft.Office.Core;
	using Extensibility;
	using System.Runtime.InteropServices;
	using EnvDTE;
	using System.Diagnostics;
	using System.IO;
	using SVNCOM;
	

	#region Read me for Add-in installation and setup information.
	// When run, the Add-in wizard prepared the registry for the Add-in.
	// At a later time, if the Add-in becomes unavailable for reasons such as:
	//   1) You moved this project to a computer other than which is was originally created on.
	//   2) You chose 'Yes' when presented with a message asking if you wish to remove the Add-in.
	//   3) Registry corruption.
	// you will need to re-register the Add-in by building the MyAddin21Setup project 
	// by right clicking the project in the Solution Explorer, then choosing install.
	#endregion
	
	[GuidAttribute("FA293E15-EB58-43F6-A08A-957B136A616B"), ProgId("SVN_NET.Connect")]
	public class Connect : Object, Extensibility.IDTExtensibility2, IDTCommandTarget
	{
		public Connect()
		{
		}

		public void OnConnection(object application, Extensibility.ext_ConnectMode connectMode, object addInInst, ref System.Array custom)
		{
			applicationObject = (_DTE)application;
			addInInstance = (AddIn)addInInst;
			if ((connectMode == Extensibility.ext_ConnectMode.ext_cm_Startup)||(connectMode == Extensibility.ext_ConnectMode.ext_cm_AfterStartup))
			//if(connectMode == Extensibility.ext_ConnectMode.ext_cm_UISetup)
			{

				if (applicationObject.CommandLineArguments.IndexOf("build")>=0)
					return;
				if (applicationObject.CommandLineArguments.IndexOf("clean")>=0)
					return;
				if (applicationObject.CommandLineArguments.IndexOf("deploy")>=0)
					return;

				object []contextGUIDS = new object[] { };
				Commands commands = applicationObject.Commands;
				_CommandBars commandBars = applicationObject.CommandBars;


				EnvDTE.Events events = applicationObject.Events;
				solutionEvents = (EnvDTE.SolutionEvents)events.SolutionEvents;
				miscFilesEvents = (EnvDTE.ProjectItemsEvents)events.MiscFilesEvents;
				solutionItemsEvents = (EnvDTE.ProjectItemsEvents)events.SolutionItemsEvents;
				try
				{
					vbProjectItemsEvents = (EnvDTE.ProjectItemsEvents)events.GetObject("VBProjectItemsEvents");
					csProjectItemsEvents = (EnvDTE.ProjectItemsEvents)events.GetObject("CSharpProjectItemsEvents");
//					vcProjectItemsEvents = (EnvDTE.ProjectItemsEvents)events.GetObject("VCProjectEngineEvents");
					vjProjectItemsEvents = (EnvDTE.ProjectItemsEvents)events.GetObject("VJSharpProjectItemsEvents");
				}
				catch (System.Exception ex)
				{
					Debug.WriteLine(ex.ToString());
				}
				
				solutionEvents.ProjectAdded += new _dispSolutionEvents_ProjectAddedEventHandler(this.ProjectAdded);
				solutionEvents.ProjectRemoved += new _dispSolutionEvents_ProjectRemovedEventHandler(this.ProjectRemoved);
				solutionEvents.ProjectRenamed += new _dispSolutionEvents_ProjectRenamedEventHandler(this.ProjectRenamed);
				solutionEvents.Renamed += new _dispSolutionEvents_RenamedEventHandler(this.Renamed);

				miscFilesEvents.ItemAdded += new _dispProjectItemsEvents_ItemAddedEventHandler(this.SolutionItemsEvents_ItemAdded);
				miscFilesEvents.ItemRemoved += new _dispProjectItemsEvents_ItemRemovedEventHandler(this.SolutionItemsEvents_ItemRemoved);
				miscFilesEvents.ItemRenamed += new _dispProjectItemsEvents_ItemRenamedEventHandler(this.SolutionItemsEvents_ItemRenamed);

				solutionItemsEvents.ItemAdded += new _dispProjectItemsEvents_ItemAddedEventHandler(this.SolutionItemsEvents_ItemAdded);
				solutionItemsEvents.ItemRemoved += new _dispProjectItemsEvents_ItemRemovedEventHandler(this.SolutionItemsEvents_ItemRemoved);
				solutionItemsEvents.ItemRenamed += new _dispProjectItemsEvents_ItemRenamedEventHandler(this.SolutionItemsEvents_ItemRenamed);

				try
				{
					vbProjectItemsEvents.ItemAdded += new _dispProjectItemsEvents_ItemAddedEventHandler(this.SolutionItemsEvents_ItemAdded);
					vbProjectItemsEvents.ItemRemoved += new _dispProjectItemsEvents_ItemRemovedEventHandler(this.SolutionItemsEvents_ItemRemoved);
					vbProjectItemsEvents.ItemRenamed += new _dispProjectItemsEvents_ItemRenamedEventHandler(this.SolutionItemsEvents_ItemRenamed);
					csProjectItemsEvents.ItemAdded += new _dispProjectItemsEvents_ItemAddedEventHandler(this.SolutionItemsEvents_ItemAdded);
					csProjectItemsEvents.ItemRemoved += new _dispProjectItemsEvents_ItemRemovedEventHandler(this.SolutionItemsEvents_ItemRemoved);
					csProjectItemsEvents.ItemRenamed += new _dispProjectItemsEvents_ItemRenamedEventHandler(this.SolutionItemsEvents_ItemRenamed);
//					vcProjectItemsEvents.ItemAdded += new _dispProjectItemsEvents_ItemAddedEventHandler(this.SolutionItemsEvents_ItemAdded);
//					vcProjectItemsEvents.ItemRemoved += new _dispProjectItemsEvents_ItemRemovedEventHandler(this.SolutionItemsEvents_ItemRemoved);
//					vcProjectItemsEvents.ItemRenamed += new _dispProjectItemsEvents_ItemRenamedEventHandler(this.SolutionItemsEvents_ItemRenamed);
					vjProjectItemsEvents.ItemAdded += new _dispProjectItemsEvents_ItemAddedEventHandler(this.SolutionItemsEvents_ItemAdded);
					vjProjectItemsEvents.ItemRemoved += new _dispProjectItemsEvents_ItemRemovedEventHandler(this.SolutionItemsEvents_ItemRemoved);
					vjProjectItemsEvents.ItemRenamed += new _dispProjectItemsEvents_ItemRenamedEventHandler(this.SolutionItemsEvents_ItemRenamed);
				}
				catch (System.Exception ex)
				{
					Debug.WriteLine(ex.ToString());
				}
	
				
				
				// When run, the Add-in wizard prepared the registry for the Add-in.
				// At a later time, the Add-in or its commands may become unavailable for reasons such as:
				//   1) You moved this project to a computer other than which is was originally created on.
				//   2) You chose 'Yes' when presented with a message asking if you wish to remove the Add-in.
				//   3) You add new commands or modify commands already defined.
				// You will need to re-register the Add-in by building the SVN_NETSetup project,
				// right-clicking the project in the Solution Explorer, and then choosing install.
				// Alternatively, you could execute the ReCreateCommands.reg file the Add-in Wizard generated in
				// the project directory, or run 'devenv /setup' from a command prompt.
//				try
//				{
//					Command command = commands.AddNamedCommand(addInInstance, "SVN_NET", "SVN_NET", "Executes the command for SVN_NET", true, 59, ref contextGUIDS, (int)vsCommandStatus.vsCommandStatusSupported+(int)vsCommandStatus.vsCommandStatusEnabled);
//					CommandBar commandBar = (CommandBar)commandBars["Tools"];
//					CommandBarControl commandBarControl = command.AddControl(commandBar, 1);
//				}
//				catch(System.Exception /*e*/)
//				{
//				}

				//create a submenu for SubVersion located under the "File" menu, right below "Source Control"
				CommandBarPopup fileSub;
				fileSub = (CommandBarPopup)applicationObject.CommandBars["File"].Controls.Add(Microsoft.Office.Core.MsoControlType.msoControlPopup, "1", "" ,applicationObject.CommandBars["File"].Controls.Count-6,false);
				fileSub.Caption = "SubVersion";
				//create a right-click menu in solution explorer when the solution is selected
				CommandBarPopup solutionSub;
				solutionSub = (CommandBarPopup)applicationObject.CommandBars["Solution"].Controls.Add(Microsoft.Office.Core.MsoControlType.msoControlPopup, "1", "" , 1,false);
				solutionSub.Caption = "SubVersion";
				//create a submenu for SubVersion as a right-click menu in solution explorer for project
				CommandBarPopup projSub;
				projSub = (CommandBarPopup)applicationObject.CommandBars["Project"].Controls.Add(Microsoft.Office.Core.MsoControlType.msoControlPopup, "1", "" , 1,false);
				projSub.Caption = "SubVersion";
				//create a submenu for SubVersion as a right-click menu in solution explorer for items
				CommandBarPopup itemSub;
				itemSub = (CommandBarPopup)applicationObject.CommandBars["Item"].Controls.Add(Microsoft.Office.Core.MsoControlType.msoControlPopup, "1", "" , 1,false);
				itemSub.Caption = "SubVersion";

				#region Commands
				//the command "Checkout" is located under "File", below New and Open
				Command checkoutcom;
				try
				{
					checkoutcom = commands.AddNamedCommand(addInInstance, "Checkout", "Checkout From Repository...", "checks out a working copy from a subversion repository", true, 0, ref contextGUIDS, (int)vsCommandStatus.vsCommandStatusSupported+(int)vsCommandStatus.vsCommandStatusEnabled);
					checkoutcom.AddControl(commandBars["File"],3);
				}
				catch (System.Exception ex)
				{
					Debug.WriteLine(ex.Message);
					checkoutcom = commands.Item("SVN_NET.Connect.Checkout",0);
				}
				AddControl(checkoutcom, "Checkout From Repository...", "File", 3);

				Command importcom;
				try
				{
					importcom = commands.AddNamedCommand(addInInstance, "Import", "Import Solution...", "imports a solution into a subversion repository", true, 0, ref contextGUIDS, (int)vsCommandStatus.vsCommandStatusSupported+(int)vsCommandStatus.vsCommandStatusEnabled);
				}
				catch (System.Exception ex)
				{
					Debug.WriteLine(ex.Message);
					importcom = commands.Item("SVN_NET.Connect.Import",0);
				}
				importcom.AddControl(fileSub.CommandBar,1);
				importcom.AddControl(solutionSub.CommandBar,1);

				Command exportcom;
				try
				{
					exportcom = commands.AddNamedCommand(addInInstance, "Export", "Export Solution...", "exports either a repository or a working copy into a clean directory", true, 0, ref contextGUIDS, (int)vsCommandStatus.vsCommandStatusSupported+(int)vsCommandStatus.vsCommandStatusEnabled);
				}
				catch (System.Exception ex)
				{
					Debug.WriteLine(ex.Message);
					exportcom = commands.Item("SVN_NET.Connect.Exports",0);
				}
				exportcom.AddControl(fileSub.CommandBar,1);
				exportcom.AddControl(solutionSub.CommandBar,1);

				Command revertcom;
				try
				{
					revertcom = commands.AddNamedCommand(addInInstance, "Revert", "Revert", "reverts the working copy to the last updated state", true, 0, ref contextGUIDS, (int)vsCommandStatus.vsCommandStatusSupported+(int)vsCommandStatus.vsCommandStatusEnabled);
				}
				catch (System.Exception ex)
				{
					Debug.WriteLine(ex.Message);
					revertcom = commands.Item("SVN_NET.Connect.Revert",0);
				}
				revertcom.AddControl(fileSub.CommandBar,1);
				revertcom.AddControl(solutionSub.CommandBar,1);

				Command revertitemcom;
				try
				{
					revertitemcom = commands.AddNamedCommand(addInInstance, "RevertItem", "Revert", "reverts the file to the last updated state", true, 0, ref contextGUIDS, (int)vsCommandStatus.vsCommandStatusSupported+(int)vsCommandStatus.vsCommandStatusEnabled);
				}
				catch (System.Exception ex)
				{
					Debug.WriteLine(ex.Message);
					revertitemcom = commands.Item("SVN_NET.Connect.RevertItem",0);
				}
				revertitemcom.AddControl(itemSub.CommandBar,1);
				revertitemcom.AddControl(projSub.CommandBar,1);

				Command switchcom;
				try
				{
					switchcom = commands.AddNamedCommand(addInInstance, "Switch", "Switch To Branch...", "switches the working copy to a given branch", true, 0, ref contextGUIDS, (int)vsCommandStatus.vsCommandStatusSupported+(int)vsCommandStatus.vsCommandStatusEnabled);
				}
				catch (System.Exception ex)
				{
					Debug.WriteLine(ex.Message);
					switchcom = commands.Item("SVN_NET.Connect.Switch",0);
				}
				switchcom.AddControl(fileSub.CommandBar,1);
				switchcom.AddControl(solutionSub.CommandBar,1);

				Command mergecom;
				try
				{
					mergecom = commands.AddNamedCommand(addInInstance, "Merge", "Merge Branches...", "merges two branches into the local one", true, 0, ref contextGUIDS, (int)vsCommandStatus.vsCommandStatusSupported+(int)vsCommandStatus.vsCommandStatusEnabled);
				}
				catch (System.Exception ex)
				{
					Debug.WriteLine(ex.Message);
					mergecom = commands.Item("SVN_NET.Connect.Merge",0);
				}
				mergecom.AddControl(fileSub.CommandBar,1);
				mergecom.AddControl(solutionSub.CommandBar,1);

				Command updatesolcom;
				try
				{
					updatesolcom = commands.AddNamedCommand(addInInstance, "UpdateSolution", "Update With Repository", "updates the working copy with the latest revision in the repository", true, 0, ref contextGUIDS, (int)vsCommandStatus.vsCommandStatusSupported+(int)vsCommandStatus.vsCommandStatusEnabled);
				}
				catch (System.Exception ex)
				{
					Debug.WriteLine(ex.Message);
					updatesolcom = commands.Item("SVN_NET.Connect.UpdateSolution",0);
				}
				updatesolcom.AddControl(fileSub.CommandBar,1);
				updatesolcom.AddControl(solutionSub.CommandBar,1);

				Command updatecom;
				try
				{
					updatecom = commands.AddNamedCommand(addInInstance, "Update", "Update With Repository", "updates the selected items with the latest revision in the repository", true, 0, ref contextGUIDS, (int)vsCommandStatus.vsCommandStatusSupported+(int)vsCommandStatus.vsCommandStatusEnabled);
				}
				catch (System.Exception ex)
				{
					Debug.WriteLine(ex.Message);
					updatecom = commands.Item("SVN_NET.Connect.Update",0);
				}
				updatecom.AddControl(itemSub.CommandBar,1);
				updatecom.AddControl(projSub.CommandBar,1);

				Command commitsolcom;
				try
				{
					commitsolcom = commands.AddNamedCommand(addInInstance, "CommitSolution", "Commit Changes...", "commit the changes to the repository", true, 0, ref contextGUIDS, (int)vsCommandStatus.vsCommandStatusSupported+(int)vsCommandStatus.vsCommandStatusEnabled);
				}
				catch (System.Exception ex)
				{
					Debug.WriteLine(ex.Message);
					commitsolcom = commands.Item("SVN_NET.Connect.CommitSolution",0);
				}
				commitsolcom.AddControl(fileSub.CommandBar,1);
				commitsolcom.AddControl(solutionSub.CommandBar,1);

				Command commitcom;
				try
				{
					commitcom = commands.AddNamedCommand(addInInstance, "Commit", "Commit Changes...", "commit the changes to the repository", true, 0, ref contextGUIDS, (int)vsCommandStatus.vsCommandStatusSupported+(int)vsCommandStatus.vsCommandStatusEnabled);
				}
				catch (System.Exception ex)
				{
					Debug.WriteLine(ex.Message);
					commitcom = commands.Item("SVN_NET.Connect.Commit",0);
				}
				commitcom.AddControl(itemSub.CommandBar,1);
				commitcom.AddControl(projSub.CommandBar,1);

				Command logsolcom;
				try
				{
					logsolcom = commands.AddNamedCommand(addInInstance, "LogSolution", "Show Log Messages...", "shows the log messages for each revision", true, 0, ref contextGUIDS, (int)vsCommandStatus.vsCommandStatusSupported+(int)vsCommandStatus.vsCommandStatusEnabled);
				}
				catch (System.Exception ex)
				{
					Debug.WriteLine(ex.Message);
					logsolcom = commands.Item("SVN_NET.Connect.LogSolution",0);
				}
				logsolcom.AddControl(fileSub.CommandBar,1);
				logsolcom.AddControl(solutionSub.CommandBar,1);

				Command logcom;
				try
				{
					logcom = commands.AddNamedCommand(addInInstance, "Log", "Show Log Messages...", "shows the log messages for each revision", true, 0, ref contextGUIDS, (int)vsCommandStatus.vsCommandStatusSupported+(int)vsCommandStatus.vsCommandStatusEnabled);
				}
				catch (System.Exception ex)
				{
					Debug.WriteLine(ex.Message);
					logcom = commands.Item("SVN_NET.Connect.Log",0);
				}
				logcom.AddControl(itemSub.CommandBar,1);
				logcom.AddControl(projSub.CommandBar,1);

				Command statuscom;
				try
				{
					statuscom = commands.AddNamedCommand(addInInstance, "Status", "Show Status...", "shows the status of the selected file", true, 0, ref contextGUIDS, (int)vsCommandStatus.vsCommandStatusSupported+(int)vsCommandStatus.vsCommandStatusEnabled);
				}
				catch (System.Exception ex)
				{
					Debug.WriteLine(ex.Message);
					statuscom = commands.Item("SVN_NET.Connect.Status",0);
				}
				statuscom.AddControl(itemSub.CommandBar,1);
				statuscom.AddControl(projSub.CommandBar,1);

				Command propscom;
				try
				{
					propscom = commands.AddNamedCommand(addInInstance, "Properties", "Properties...", "shows the file properties and lets you edit them", true, 0, ref contextGUIDS, (int)vsCommandStatus.vsCommandStatusSupported+(int)vsCommandStatus.vsCommandStatusEnabled);
				}
				catch (System.Exception ex)
				{
					Debug.WriteLine(ex.Message);
					propscom = commands.Item("SVN_NET.Connect.Properties",0);
				}
				propscom.AddControl(itemSub.CommandBar,1);
				propscom.AddControl(projSub.CommandBar,1);
				#endregion
			}
		}


		private void AddControl(Command com, String caption, String cBar, int index)
		{
			bool found = false;
			foreach (CommandBarControl ctrl in applicationObject.CommandBars[cBar].Controls)
			{
				if (ctrl.Caption.IndexOf(caption)>=0)
					found = true;
			}
			if (!found)
				com.AddControl(applicationObject.CommandBars[cBar],index);
		}

		public void OnDisconnection(Extensibility.ext_DisconnectMode disconnectMode, ref System.Array custom)
		{
			if(solutionEvents != null)
			{
				solutionEvents.ProjectAdded -= new _dispSolutionEvents_ProjectAddedEventHandler(this.ProjectAdded);
				solutionEvents.ProjectRemoved -= new _dispSolutionEvents_ProjectRemovedEventHandler(this.ProjectRemoved);
				solutionEvents.ProjectRenamed -= new _dispSolutionEvents_ProjectRenamedEventHandler(this.ProjectRenamed);
				solutionEvents.Renamed -= new _dispSolutionEvents_RenamedEventHandler(this.Renamed);
			}
			if(miscFilesEvents != null)
			{
				miscFilesEvents.ItemAdded -= new _dispProjectItemsEvents_ItemAddedEventHandler(this.SolutionItemsEvents_ItemAdded);
				miscFilesEvents.ItemRemoved -= new _dispProjectItemsEvents_ItemRemovedEventHandler(this.SolutionItemsEvents_ItemRemoved);
				miscFilesEvents.ItemRenamed -= new _dispProjectItemsEvents_ItemRenamedEventHandler(this.SolutionItemsEvents_ItemRenamed);
			}

			if(solutionItemsEvents != null)
			{
				solutionItemsEvents.ItemAdded -= new _dispProjectItemsEvents_ItemAddedEventHandler(this.SolutionItemsEvents_ItemAdded);
				solutionItemsEvents.ItemRemoved -= new _dispProjectItemsEvents_ItemRemovedEventHandler(this.SolutionItemsEvents_ItemRemoved);
				solutionItemsEvents.ItemRenamed -= new _dispProjectItemsEvents_ItemRenamedEventHandler(this.SolutionItemsEvents_ItemRenamed);
			}

			if(vbProjectItemsEvents != null)
			{
				vbProjectItemsEvents.ItemAdded -= new _dispProjectItemsEvents_ItemAddedEventHandler(this.SolutionItemsEvents_ItemAdded);
				vbProjectItemsEvents.ItemRemoved -= new _dispProjectItemsEvents_ItemRemovedEventHandler(this.SolutionItemsEvents_ItemRemoved);
				vbProjectItemsEvents.ItemRenamed -= new _dispProjectItemsEvents_ItemRenamedEventHandler(this.SolutionItemsEvents_ItemRenamed);
			}
		
			if(vcProjectItemsEvents != null)
			{
				csProjectItemsEvents.ItemAdded -= new _dispProjectItemsEvents_ItemAddedEventHandler(this.SolutionItemsEvents_ItemAdded);
				csProjectItemsEvents.ItemRemoved -= new _dispProjectItemsEvents_ItemRemovedEventHandler(this.SolutionItemsEvents_ItemRemoved);
				csProjectItemsEvents.ItemRenamed -= new _dispProjectItemsEvents_ItemRenamedEventHandler(this.SolutionItemsEvents_ItemRenamed);
			}
		
			if(vcProjectItemsEvents != null)
			{
				vcProjectItemsEvents.ItemAdded -= new _dispProjectItemsEvents_ItemAddedEventHandler(this.SolutionItemsEvents_ItemAdded);
				vcProjectItemsEvents.ItemRemoved -= new _dispProjectItemsEvents_ItemRemovedEventHandler(this.SolutionItemsEvents_ItemRemoved);
				vcProjectItemsEvents.ItemRenamed -= new _dispProjectItemsEvents_ItemRenamedEventHandler(this.SolutionItemsEvents_ItemRenamed);
			}

			if(vjProjectItemsEvents != null)
			{
				vjProjectItemsEvents.ItemAdded -= new _dispProjectItemsEvents_ItemAddedEventHandler(this.SolutionItemsEvents_ItemAdded);
				vjProjectItemsEvents.ItemRemoved -= new _dispProjectItemsEvents_ItemRemovedEventHandler(this.SolutionItemsEvents_ItemRemoved);
				vjProjectItemsEvents.ItemRenamed -= new _dispProjectItemsEvents_ItemRenamedEventHandler(this.SolutionItemsEvents_ItemRenamed);
			}
		}

		public void OnAddInsUpdate(ref System.Array custom)
		{
		}

		public void OnStartupComplete(ref System.Array custom)
		{
		}

		public void OnBeginShutdown(ref System.Array custom)
		{
		}
		
		public void QueryStatus(string commandName, EnvDTE.vsCommandStatusTextWanted neededText, ref EnvDTE.vsCommandStatus status, ref object commandText)
		{
			if(neededText == EnvDTE.vsCommandStatusTextWanted.vsCommandStatusTextWantedNone)
			{
				if(commandName == "SVN_NET.Connect.Checkout")
				{
					status = (vsCommandStatus)vsCommandStatus.vsCommandStatusSupported|vsCommandStatus.vsCommandStatusEnabled;
				}
				if (commandName == "SVN_NET.Connect.Import")
				{
					if (applicationObject.Solution.IsOpen)
						status = (vsCommandStatus)vsCommandStatus.vsCommandStatusSupported|vsCommandStatus.vsCommandStatusEnabled;
				}
				if (commandName == "SVN_NET.Connect.Export")
				{
					status = (vsCommandStatus)vsCommandStatus.vsCommandStatusSupported|vsCommandStatus.vsCommandStatusEnabled;
				}
				if (commandName == "SVN_NET.Connect.Revert")
				{
					if (applicationObject.Solution.IsOpen)
						status = (vsCommandStatus)vsCommandStatus.vsCommandStatusSupported|vsCommandStatus.vsCommandStatusEnabled;
				}
				if (commandName == "SVN_NET.Connect.RevertItem")
				{
					if (applicationObject.Solution.IsOpen)
						status = (vsCommandStatus)vsCommandStatus.vsCommandStatusSupported|vsCommandStatus.vsCommandStatusEnabled;
				}
				if (commandName == "SVN_NET.Connect.Switch")
				{
					if (applicationObject.Solution.IsOpen)
						status = (vsCommandStatus)vsCommandStatus.vsCommandStatusSupported|vsCommandStatus.vsCommandStatusEnabled;
				}
				if (commandName == "SVN_NET.Connect.Merge")
				{
					if (applicationObject.Solution.IsOpen)
						status = (vsCommandStatus)vsCommandStatus.vsCommandStatusSupported|vsCommandStatus.vsCommandStatusEnabled;
				}
				if (commandName == "SVN_NET.Connect.UpdateSolution")
				{
					if (applicationObject.Solution.IsOpen)
						status = (vsCommandStatus)vsCommandStatus.vsCommandStatusSupported|vsCommandStatus.vsCommandStatusEnabled;
				}
				if (commandName == "SVN_NET.Connect.Update")
				{
					if (applicationObject.Solution.IsOpen)
						status = (vsCommandStatus)vsCommandStatus.vsCommandStatusSupported|vsCommandStatus.vsCommandStatusEnabled;
				}
				if (commandName == "SVN_NET.Connect.CommitSolution")
				{
					if (applicationObject.Solution.IsOpen)
						status = (vsCommandStatus)vsCommandStatus.vsCommandStatusSupported|vsCommandStatus.vsCommandStatusEnabled;
				}
				if (commandName == "SVN_NET.Connect.Commit")
				{
					if (applicationObject.Solution.IsOpen)
						status = (vsCommandStatus)vsCommandStatus.vsCommandStatusSupported|vsCommandStatus.vsCommandStatusEnabled;
				}
				if (commandName == "SVN_NET.Connect.LogSolution")
				{
					if (applicationObject.Solution.IsOpen)
						status = (vsCommandStatus)vsCommandStatus.vsCommandStatusSupported|vsCommandStatus.vsCommandStatusEnabled;
				}
				if (commandName == "SVN_NET.Connect.Log")
				{
					if (applicationObject.Solution.IsOpen)
						status = (vsCommandStatus)vsCommandStatus.vsCommandStatusSupported|vsCommandStatus.vsCommandStatusEnabled;
				}
				if (commandName == "SVN_NET.Connect.Status")
				{
					if (applicationObject.Solution.IsOpen)
						status = (vsCommandStatus)vsCommandStatus.vsCommandStatusSupported|vsCommandStatus.vsCommandStatusEnabled;
				}
				if (commandName == "SVN_NET.Connect.Properties")
				{
					if (applicationObject.Solution.IsOpen)
						status = (vsCommandStatus)vsCommandStatus.vsCommandStatusSupported|vsCommandStatus.vsCommandStatusEnabled;
				}
			}
		}

		public void Exec(string commandName, EnvDTE.vsCommandExecOption executeOption, ref object varIn, ref object varOut, ref bool handled)
		{
			handled = false;
			if(executeOption == EnvDTE.vsCommandExecOption.vsCommandExecOptionDoDefault)
			{
				#region Checkout
				if(commandName == "SVN_NET.Connect.Checkout")
				{
					CheckoutForm cf = new CheckoutForm();
					if (cf.ShowDialog() == System.Windows.Forms.DialogResult.OK)
					{
						Debug.WriteLine("checkout successful");
						//look for *.sln or *.dsw files and open the first one found.
						DirectoryInfo di = new DirectoryInfo(cf.savelocation.Text);
						FileInfo[] fiArr = di.GetFiles();
						foreach (FileInfo fri in fiArr)
						{
							if (fri.FullName.EndsWith(".sln"))
							{
								applicationObject.Solution.Open(fri.FullName);
								handled = true;
								return;
							}
						}
						foreach (FileInfo fri in fiArr)
						{
							if (fri.FullName.EndsWith(".dsw"))
							{
								applicationObject.Solution.Open(fri.FullName);
								handled = true;
								return;
							}
						}
					}
					else
						Debug.WriteLine("checkout cancelled");
					handled = true;
					return;
				}
				#endregion
				#region Import
				if (commandName == "SVN_NET.Connect.Import")
				{
					ImportForm imf = new ImportForm();
					imf.SetAppObj(applicationObject);
					if (imf.ShowDialog() == System.Windows.Forms.DialogResult.OK)
					{
						Debug.WriteLine("import successful");
					}
					handled = true;
					return;
				}
				#endregion
				#region Export
				if (commandName == "SVN_NET.Connect.Export")
				{
					ExportForm ef = new ExportForm();
					ef.SetAppObj(applicationObject);
					if (ef.ShowDialog() == System.Windows.Forms.DialogResult.OK)
					{
						Debug.WriteLine("export successful");
					}
					handled = true;
					return;
				}
				#endregion
				#region Revert
				if (commandName == "SVN_NET.Connect.Revert")
				{
					if (System.Windows.Forms.MessageBox.Show("Do you really want to revert your changes to the last updated version?",
						"Revert", System.Windows.Forms.MessageBoxButtons.YesNo)
						== System.Windows.Forms.DialogResult.Yes)
					{
						//Question answered with YES
						SVNCOM.SVN svn = new SVNCOM.SVN();
						string path = applicationObject.Solution.FullName;
						applicationObject.Solution.Close(true);
						try
						{
							svn.Revert(Path.GetDirectoryName(path),true);
						}
						catch (System.Exception ex)
						{
							Debug.WriteLine(ex.Message);
							System.Windows.Forms.MessageBox.Show(ex.Message,"Revert");
						}
						applicationObject.Solution.Open(path);
						System.Windows.Forms.MessageBox.Show("Revert finished","Revert");
					}
				}
				#endregion
				#region RevertItem
				if (commandName == "SVN_NET.Connect.RevertItem")
				{
					if (System.Windows.Forms.MessageBox.Show("Do you really want to revert your changes to the last updated version?",
						"Revert", System.Windows.Forms.MessageBoxButtons.YesNo)
						== System.Windows.Forms.DialogResult.Yes)
					{
						//Question answered with YES
						SVNCOM.SVN svn = new SVNCOM.SVN();
						string path = applicationObject.Solution.FullName;
						applicationObject.Documents.SaveAll();
						string[] items = GetSelectedSolutionItems();
						applicationObject.StatusBar.Progress(true,"",0,items.Length);
						for (int i=0; i<items.Length; i++)
						{
							string str = items[i];
							if (str.EndsWith("proj"))		//check if it is a project file
								applicationObject.Solution.Close(true);
							Debug.WriteLine("reverting "+str);
							try
							{
								svn.Revert(str,false);
							}
							catch (System.Exception ex)
							{
								Debug.WriteLine(ex.Message);
								System.Windows.Forms.MessageBox.Show(ex.Message,"Revert");
							}
							applicationObject.StatusBar.Progress(true,str,i,items.Length);
						}
						if (!applicationObject.Solution.IsOpen)
						{
							applicationObject.Solution.Open(path);
						}
						applicationObject.StatusBar.Progress(false,"",0,100);
					}
				}
				#endregion
				#region Switch
				if (commandName == "SVN_NET.Connect.Switch")
				{
					SwitchForm sf = new SwitchForm();
					sf.SetAppObj(applicationObject);
					if (sf.ShowDialog() == System.Windows.Forms.DialogResult.OK)
					{
						Debug.WriteLine("switch successful");
					}
					handled = true;
					return;
				}
				#endregion
				#region Merge
				if (commandName == "SVN_NET.Connect.Merge")
				{
					MergeForm mf = new MergeForm();
					mf.SetAppObj(applicationObject);
					if (mf.ShowDialog() == System.Windows.Forms.DialogResult.OK)
					{
						Debug.WriteLine("merge successful");
					}
					handled = true;
					return;
				}
				#endregion
				#region UpdateSolution
				if (commandName == "SVN_NET.Connect.UpdateSolution")
				{
					UpdateForm uf = new UpdateForm();
					uf.SetUpdateDir(Path.GetDirectoryName(applicationObject.Solution.FullName));
					uf.ShowDialog();
					handled = true;
					return;
				}
				#endregion
				#region Update
				if (commandName == "SVN_NET.Connect.Update")
				{
					applicationObject.Documents.SaveAll();
					string path = applicationObject.Solution.FullName;
					UpdateForm uf = new UpdateForm();
					string[] items = GetSelectedSolutionItems();
					if (items.Length == 0)
					{
						handled = true;
						return;
					}
					string str = items[0];
					if (str.EndsWith("proj"))
						applicationObject.Solution.Close(true);
					for (int i=1; i<items.Length; i++)
					{
						str = str+";"+items[i];
						if (items[i].EndsWith("proj"))
							applicationObject.Solution.Close(true);
					}
					uf.SetUpdateDir(str);
					uf.ShowDialog();

					if (!applicationObject.Solution.IsOpen)
						applicationObject.Solution.Open(path);
					handled = true;
					return;
				}
				#endregion
				#region CommitSolution
				if (commandName == "SVN_NET.Connect.CommitSolution")
				{
					CommitForm cf = new CommitForm();
					cf.SetUpdateDir(Path.GetDirectoryName(applicationObject.Solution.FullName));
					cf.ShowDialog();
					handled = true;
					return;
				}
				#endregion
				#region Commit
				if (commandName == "SVN_NET.Connect.Commit")
				{
					applicationObject.Documents.SaveAll();
					string path = applicationObject.Solution.FullName;
					CommitForm cf = new CommitForm();
					string[] items = GetSelectedSolutionItems();
					if (items.Length == 0)
					{
						handled = true;
						return;
					}
					string str = items[0];
					if (str.EndsWith("proj"))
						applicationObject.Solution.Close(true);
					for (int i=1; i<items.Length; i++)
					{
						str = str+";"+items[i];
						if (items[i].EndsWith("proj"))
							applicationObject.Solution.Close(true);
					}
					cf.SetUpdateDir(str);
					cf.ShowDialog();

					if (!applicationObject.Solution.IsOpen)
						applicationObject.Solution.Open(path);
					handled = true;
					return;
				}
				#endregion
				#region LogSolution
				if (commandName == "SVN_NET.Connect.LogSolution")
				{
					LogForm lf = new LogForm();
					lf.SetLogDir(Path.GetDirectoryName(applicationObject.Solution.FullName));
					lf.ShowDialog();
					handled = true;
					return;
				}
				#endregion
				#region Log
				if (commandName == "SVN_NET.Connect.Log")
				{
					LogForm lf = new LogForm();
					string[] items = GetSelectedSolutionItems();
					if (items.Length == 0)
					{
						handled = true;
						return;
					}
					string str = items[0];
					for (int i=1; i<items.Length; i++)
					{
						str = str+";"+items[i];
					}
					lf.SetLogDir(str);
					lf.ShowDialog();
					handled = true;
					return;
				}
				#endregion
				#region Status
				if (commandName == "SVN_NET.Connect.Status")
				{
					StatusForm sf = new StatusForm();
					string[] items = GetSelectedSolutionItems();
					if (items.Length != 1)
					{
						System.Windows.Forms.MessageBox.Show("please select only one file to show the status for!","Status");
						handled = true;
						return;
					}
					sf.SetPath(items[0]);
					sf.ShowDialog();
					handled = true;
					return;
				}
				#endregion
				#region Properties
				if (commandName == "SVN_NET.Connect.Properties")
				{
					PropertiesForm pf = new PropertiesForm();
					string [] items = GetSelectedSolutionItems();
					if (items.Length != 1)
					{
						System.Windows.Forms.MessageBox.Show("please select only one file for the properties!","Properties");
						handled = true;
						return;
					}
					pf.SetPath(items[0]);
					pf.ShowDialog();
					handled = true;
					return;
				}
				#endregion
			}
		}
		
		private string[] GetSelectedSolutionItems()
		{
			int count = 0;
			foreach (SelectedItem si in applicationObject.SelectedItems)
			{
				if (si.Project is Project)
				{
					Project p = si.Project;
					foreach (ProjectItem pi in p.ProjectItems)
					{
						if (pi.Kind == Constants.vsProjectItemKindPhysicalFile)
							count++;
					}
				}
				if ((si.ProjectItem is ProjectItem)&&(si.ProjectItem.Kind == Constants.vsProjectItemKindPhysicalFile))
				{
					count++;
				}
			}
			string[] str = new String[count];
			count = 0;
			foreach (SelectedItem si in applicationObject.SelectedItems)
			{
				if (si.Project is Project)
				{
					Project p = si.Project;
					foreach (ProjectItem pi in p.ProjectItems)
					{
						if (pi.Kind == Constants.vsProjectItemKindPhysicalFile)
							str[count++] = pi.get_FileNames(0);
					}
				}
				if ((si.ProjectItem is ProjectItem)&&(si.ProjectItem.Kind == Constants.vsProjectItemKindPhysicalFile))
				{
					str[count++] = si.ProjectItem.get_FileNames(0);
				}
			}
			return str;
		}
		
		#region SolutionEvents
		public void ProjectAdded(EnvDTE.Project project)
		{
			//first add the eventhandler to the project
			try
			{
				Microsoft.VisualStudio.VCProjectEngine.VCProjectEngine eng;
				Microsoft.VisualStudio.VCProjectEngine.VCProjectEngineEvents evt;
				eng = ((Microsoft.VisualStudio.VCProjectEngine.VCProject)project).VCProjectEngine;
				evt = eng.Events;
				evt.ItemAdded += new Microsoft.VisualStudio.VCProjectEngine._dispVCProjectEngineEvents_ItemAddedEventHandler(this.VCItemAdded);
			}
			catch (System.Exception ex)
			{
				Debug.WriteLine(ex.ToString());
			}


			if (Path.GetDirectoryName(project.FullName).StartsWith(Path.GetDirectoryName(applicationObject.Solution.FullName)))
			{
				try
				{
					SVNCOM.SVN svn = new SVNCOM.SVN();
					svn.Add(project.FullName, false);			//first add the project file itself
					Debug.WriteLine("added file : "+project.FullName);
					foreach (ProjectItem item in project.ProjectItems)
					{
						if ((item.Kind == Constants.vsProjectItemKindPhysicalFile)||(item.Kind == Constants.vsProjectItemKindPhysicalFolder))
						{
							Debug.WriteLine("added file : "+item.get_FileNames(1));
							svn.Add(item.get_FileNames(1),false);
						}
					}
				}
				catch (System.Exception ex)
				{
					Debug.WriteLine(ex.ToString());
				}
			}
			else 
				Debug.WriteLine("project not in solution path");
		}
		public void ProjectRemoved(EnvDTE.Project project)
		{
			if (Path.GetDirectoryName(project.FullName).StartsWith(Path.GetDirectoryName(applicationObject.Solution.FullName)))
			{
				try
				{
					if (System.Windows.Forms.MessageBox.Show("do you want to remove the project and all items in it also from Subversion source control? If you choose yes then the files will also be deleted!", 
						"Project removed", System.Windows.Forms.MessageBoxButtons.YesNo)==
						System.Windows.Forms.DialogResult.Yes)
					{
						SVNCOM.SVN svn = new SVNCOM.SVN();
						svn.Remove(project.FullName, true);
						Debug.WriteLine("removed file : "+project.FullName);
						foreach (ProjectItem item in project.ProjectItems)
						{
							if ((item.Kind == Constants.vsProjectItemKindPhysicalFile)||(item.Kind == Constants.vsProjectItemKindPhysicalFolder))
							{
								Debug.WriteLine("removed file : "+item.get_FileNames(1));
								svn.Remove(item.get_FileNames(1), true);
							}
						}
					}

				}
				catch (System.Exception ex)
				{
					Debug.WriteLine(ex.ToString());
				}
			}
			else 
				Debug.WriteLine("project not in solution path");
		}
		public void ProjectRenamed(EnvDTE.Project project, string oldName)
		{
			try
			{
				Debug.WriteLine("project rename from "+oldName+" to "+project.FullName);
				SVNCOM.SVN svn = new SVNCOM.SVN();
				svn.Move(oldName, project.FullName, true);
				Debug.WriteLine("project renamed successfully");
			}
			catch (System.Exception ex)
			{
				Debug.WriteLine(ex.ToString());
			}
		}
		public void Renamed(string oldName)
		{
			try
			{
				Debug.WriteLine("solution rename from "+oldName+" to "+applicationObject.Solution.FullName);
				SVNCOM.SVN svn = new SVNCOM.SVN();
				svn.Move(oldName, applicationObject.Solution.FullName, true);
				Debug.WriteLine("solution renamed successfully");
			}
			catch (System.Exception ex)
			{
				Debug.WriteLine(ex.ToString());
			}
		}
		#endregion
	
		#region SolutionItemsEvents
		public void SolutionItemsEvents_ItemAdded(EnvDTE.ProjectItem projectItem)
		{
			try
			{
				SVNCOM.SVN svn = new SVNCOM.SVN();
				for (short i=1; i<=projectItem.FileCount; i++)
				{
					svn.Add(projectItem.get_FileNames(i), false);
					Debug.WriteLine("added item : "+projectItem.get_FileNames(i));
				}
			}
			catch (System.Exception ex)
			{
				Debug.WriteLine(ex.ToString());
			}
		}
		public void SolutionItemsEvents_ItemRemoved(EnvDTE.ProjectItem projectItem)
		{
			if (System.Windows.Forms.MessageBox.Show("do you want to remove the item also from Subversion source control? If you choose yes then the file will also be deleted!", 
				"Item removed", System.Windows.Forms.MessageBoxButtons.YesNo)==
				System.Windows.Forms.DialogResult.Yes)
			{
				try
				{
					SVNCOM.SVN svn = new SVNCOM.SVN();
					for (short i=1; i<=projectItem.FileCount; i++)
					{
						svn.Remove(projectItem.get_FileNames(i), true);
						Debug.WriteLine("removed item : "+projectItem.get_FileNames(i));
					}
				}
				catch (System.Exception ex)
				{
					Debug.WriteLine(ex.ToString());
				}
			}
		}
		public void SolutionItemsEvents_ItemRenamed(EnvDTE.ProjectItem projectItem, string OldName)
		{
			try
			{
				SVNCOM.SVN svn = new SVNCOM.SVN();
				for (int i=1; i<=projectItem.FileCount; i++)
				{
					svn.Move(OldName, projectItem.get_FileNames(0), true);
					Debug.WriteLine("moved item : "+OldName+" to "+projectItem.get_FileNames(0));
				}
			}
			catch (System.Exception ex)
			{
				Debug.WriteLine(ex.ToString());
			}
		}
		#endregion
		
		
		
		
		
		private _DTE applicationObject;
		private AddIn addInInstance;

		private EnvDTE.SolutionEvents solutionEvents;
		private EnvDTE.ProjectItemsEvents miscFilesEvents;
		private EnvDTE.ProjectItemsEvents solutionItemsEvents;
		private EnvDTE.ProjectItemsEvents vbProjectItemsEvents;
		private EnvDTE.ProjectItemsEvents csProjectItemsEvents;
//		private EnvDTE.ProjectItemsEvents vcProjectItemsEvents;
		private EnvDTE.ProjectItemsEvents vjProjectItemsEvents;
	}
}