using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Threading;
using System.Diagnostics;
using System.IO;
using EnvDTE;
using SVNCOM;

namespace SVN_NET
{
	/// <summary>
	/// Summary description for LogForm.
	/// </summary>
	public class LogForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox outputBox;

		private string logdir;
		private SVNCOM.SVN svn;
		private System.Windows.Forms.Button cancelButton;
		private System.Windows.Forms.Panel inputPanel;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button logButton;
		private System.Windows.Forms.NumericUpDown revstart;
		private System.Windows.Forms.NumericUpDown revend;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public LogForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.cancelButton = new System.Windows.Forms.Button();
			this.outputBox = new System.Windows.Forms.TextBox();
			this.inputPanel = new System.Windows.Forms.Panel();
			this.revend = new System.Windows.Forms.NumericUpDown();
			this.revstart = new System.Windows.Forms.NumericUpDown();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.logButton = new System.Windows.Forms.Button();
			this.inputPanel.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.revend)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.revstart)).BeginInit();
			this.SuspendLayout();
			// 
			// cancelButton
			// 
			this.cancelButton.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.cancelButton.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cancelButton.Location = new System.Drawing.Point(224, 144);
			this.cancelButton.Name = "cancelButton";
			this.cancelButton.TabIndex = 13;
			this.cancelButton.Text = "cancel";
			// 
			// outputBox
			// 
			this.outputBox.AcceptsReturn = true;
			this.outputBox.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.outputBox.CausesValidation = false;
			this.outputBox.MaxLength = 0;
			this.outputBox.Multiline = true;
			this.outputBox.Name = "outputBox";
			this.outputBox.ReadOnly = true;
			this.outputBox.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.outputBox.Size = new System.Drawing.Size(304, 136);
			this.outputBox.TabIndex = 12;
			this.outputBox.Text = "";
			this.outputBox.Visible = false;
			this.outputBox.WordWrap = false;
			// 
			// inputPanel
			// 
			this.inputPanel.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.inputPanel.Controls.AddRange(new System.Windows.Forms.Control[] {
																					 this.revend,
																					 this.revstart,
																					 this.label2,
																					 this.label1});
			this.inputPanel.Location = new System.Drawing.Point(8, 8);
			this.inputPanel.Name = "inputPanel";
			this.inputPanel.Size = new System.Drawing.Size(296, 108);
			this.inputPanel.TabIndex = 14;
			// 
			// revend
			// 
			this.revend.Location = new System.Drawing.Point(160, 64);
			this.revend.Name = "revend";
			this.revend.TabIndex = 8;
			// 
			// revstart
			// 
			this.revstart.Location = new System.Drawing.Point(160, 24);
			this.revstart.Name = "revstart";
			this.revstart.TabIndex = 7;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(12, 64);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(108, 16);
			this.label2.TabIndex = 6;
			this.label2.Text = "end at revision:";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(12, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(92, 16);
			this.label1.TabIndex = 5;
			this.label1.Text = "start at revision:";
			// 
			// logButton
			// 
			this.logButton.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.logButton.Location = new System.Drawing.Point(128, 144);
			this.logButton.Name = "logButton";
			this.logButton.Size = new System.Drawing.Size(83, 23);
			this.logButton.TabIndex = 15;
			this.logButton.Text = "show logs";
			this.logButton.Click += new System.EventHandler(this.logButton_Click);
			// 
			// LogForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(304, 174);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.logButton,
																		  this.inputPanel,
																		  this.cancelButton,
																		  this.outputBox});
			this.Name = "LogForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "LogForm";
			this.inputPanel.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.revend)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.revstart)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void logButton_Click(object sender, System.EventArgs e)
		{
			if (this.logButton.Text == "OK")
			{
				this.DialogResult = DialogResult.OK;
				this.Close();
				return;
			}
			this.logButton.Text = "OK";
			this.logButton.Enabled = false;
			this.inputPanel.Visible = false;
			this.outputBox.Visible = true;
			System.Threading.Thread t = new System.Threading.Thread(new ThreadStart(LogThread));
			t.IsBackground = true;
			t.Name = "Update";
			t.Start();	
		}

		private void LogThread()
		{
			svn = new SVNCOM.SVN();
			SVNCOM._ISVNEvents_PromptEventHandler prompteventobj = new SVNCOM._ISVNEvents_PromptEventHandler(this.Prompt);
			svn.Prompt += prompteventobj;
			SVNCOM._ISVNEvents_LogEventHandler logeventobj = new SVNCOM._ISVNEvents_LogEventHandler(this.LogEvent);
			svn.Log += logeventobj;
			try
			{
				Invoke(new LogDelegate(SetMessage), new object [] {"receiving log entries..."});
				svn.ReceiveLog(logdir, (int)revstart.Value, (int)revend.Value, false);
				Invoke(new LogDelegate(SetMessage), new object [] {"SVN_END"});
			}
			catch (ThreadAbortException)
			{
				Invoke(new LogDelegate(SetMessage), new object [] {"Exception"});
			}
			catch (System.Exception ex)
			{
				System.Windows.Forms.MessageBox.Show(ex.Message,"Log");
				Invoke(new LogDelegate(SetMessage), new object [] {"Exception"});
			}
			svn.Prompt -= prompteventobj;
			svn.Log -= logeventobj;
		}

		private void LogEvent(int rev, string author, string date, string message)
		{
			Invoke(new LogDelegate(SetMessage), new object [] {"Rev: "+rev});
			Invoke(new LogDelegate(SetMessage), new object [] {"author: "+author});
			Invoke(new LogDelegate(SetMessage), new object [] {"date: "+date});
			string[] str = message.Split(new char[] {'\n','\r'});
			foreach (string line in str)
			{
				if (line.Length > 0)
					Invoke(new LogDelegate(SetMessage), new object [] {"message: "+line});
			}
			Invoke(new LogDelegate(SetMessage), new object [] {"---------------------------------"});
		}


		private void SetMessage(string str)
		{
			if (str.IndexOf("Exception")>=0)
			{
				this.logButton.Enabled = true;
				return;
			}
			if (str.IndexOf("SVN_END")>=0)
			{
				this.logButton.Enabled = true;
				return;
			}
			outputBox.AppendText(str);
			outputBox.AppendText(Environment.NewLine);
		}

		private void Prompt(out string info, string prompt, bool hide)
		{
			PromptForm pf = new PromptForm();
			pf.SetValues(prompt,hide);
			info="";
			if (pf.ShowDialog()==System.Windows.Forms.DialogResult.OK)
			{
				info = pf.GetInfo();
			}
			else
				info = "";
		}

		public void SetLogDir(string str)
		{
			logdir = str;
			SVNCOM.SVN svn = new SVNCOM.SVN();
			string files = logdir;
			if (files.IndexOf(";")>=0)
			{
				files = files.Substring(0,files.IndexOf(";"));
				Debug.WriteLine(files);
			}
			SVNCOM.SVNStatusClass status = (SVNCOM.SVNStatusClass)svn.GetFileStatus(false, files);
			revend.Maximum = status.revision;
			revend.Value = status.revision;
			revstart.Maximum = revend.Value;
			if (revend.Value > 10)
				revstart.Value = status.revision - 10;
		}



	}
	public delegate void LogDelegate(string message);
}
