using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Threading;
using System.Diagnostics;
using System.IO;
using System.Text;
using EnvDTE;
using SVNCOM;

namespace SVN_NET
{
	/// <summary>
	/// Summary description for PropertiesForm.
	/// </summary>
	public class PropertiesForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ListBox propertiesBox;
		private System.Windows.Forms.Button okButton;
		private System.Windows.Forms.Button addButton;
		private System.Windows.Forms.Button deleteButton;

		private string filepath;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public PropertiesForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.propertiesBox = new System.Windows.Forms.ListBox();
			this.okButton = new System.Windows.Forms.Button();
			this.addButton = new System.Windows.Forms.Button();
			this.deleteButton = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// propertiesBox
			// 
			this.propertiesBox.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.propertiesBox.Name = "propertiesBox";
			this.propertiesBox.Size = new System.Drawing.Size(328, 82);
			this.propertiesBox.TabIndex = 0;
			// 
			// okButton
			// 
			this.okButton.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.okButton.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.okButton.Location = new System.Drawing.Point(248, 96);
			this.okButton.Name = "okButton";
			this.okButton.TabIndex = 1;
			this.okButton.Text = "OK";
			// 
			// addButton
			// 
			this.addButton.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
			this.addButton.Location = new System.Drawing.Point(128, 96);
			this.addButton.Name = "addButton";
			this.addButton.TabIndex = 2;
			this.addButton.Text = "Add";
			this.addButton.Click += new System.EventHandler(this.addButton_Click);
			// 
			// deleteButton
			// 
			this.deleteButton.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.deleteButton.Location = new System.Drawing.Point(8, 96);
			this.deleteButton.Name = "deleteButton";
			this.deleteButton.TabIndex = 3;
			this.deleteButton.Text = "Delete";
			this.deleteButton.Click += new System.EventHandler(this.deleteButton_Click);
			// 
			// PropertiesForm
			// 
			this.AcceptButton = this.okButton;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(328, 126);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.deleteButton,
																		  this.addButton,
																		  this.okButton,
																		  this.propertiesBox});
			this.Name = "PropertiesForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "PropertiesForm";
			this.ResumeLayout(false);

		}
		#endregion
	
		public void SetPath(string path)
		{
			filepath = path;
			SVNCOM.SVN svn = new SVNCOM.SVN();
			SVNCOM.SVNProperties svnprops = (SVNProperties)svn.GetProperties(path);
			FillData(svnprops);
		}

		private void FillData(SVNProperties props)
		{
			try
			{
				this.propertiesBox.Items.Clear();
				for (int i=0; i<props.Count; i++)
				{
					SVNProperty prop = (SVNProperty)props.Item(i);
					this.propertiesBox.Items.Add(prop.name + " -> " + prop.Value);
				}
			}
			catch (System.Exception ex)
			{
				Debug.WriteLine(ex.ToString());
			}
		}

		private void addButton_Click(object sender, System.EventArgs e)
		{
			PropertyForm pf = new PropertyForm();
			if (pf.ShowDialog() == DialogResult.OK)
			{
				try
				{
					SVNCOM.SVN svn = new SVNCOM.SVN();
					SVNCOM.SVNProperties svnprops = (SVNProperties)svn.GetProperties(filepath);
					SVNCOM.SVNProperty prop = new SVNCOM.SVNPropertyClass();
					prop.name = pf.nameBox.Text;
					prop.Value = pf.valueBox.Text;
					svnprops.Add(prop,false);
					FillData(svnprops);
				}
				catch (System.Exception ex)
				{
					Debug.WriteLine(ex.ToString());
				}
			}
		}

		private void deleteButton_Click(object sender, System.EventArgs e)
		{
			try
			{
				if (propertiesBox.SelectedIndex >= 0)
				{
					SVNCOM.SVN svn = new SVNCOM.SVN();
					SVNCOM.SVNProperties svnprops = (SVNProperties)svn.GetProperties(filepath);
					SVNCOM.SVNProperty prop = (SVNProperty)svnprops.Item(propertiesBox.SelectedIndex);
					if (MessageBox.Show("do you really want to delete the property "+prop.name+" with the value "+prop.Value+" ?","Properties", MessageBoxButtons.YesNo)==DialogResult.Yes)
					{
						svnprops.Remove(prop,false);
						FillData(svnprops);
					}
				}
			}
			catch (System.Exception ex)
			{
				Debug.WriteLine(ex.ToString());
			}
		}
	}
}
